//FFSubmenu=Effekte
//FFName=Verzerrungen

//*************************************************************************
//**************************** Verzerrungen *******************************
//*************************************************************************
//************ nach Idee und Konzept von Walter Wichmann ******************
//******** modifiziert und weiterentwickelt von Heinrich Schnepf **********
//************             Januar -  Mrz 2013           ******************
//*************************************************************************

var VERSION='1.92';
var SHFT_DLG='Verzerrungen / Version: ' + VERSION;
var CalcInfo="Verzerrung in Arbeit, bitte warten! Stopp mit Leertaste!";

var previewSize=384;
var orgWi,orgHi,previewHi,modWi,modHi;	

var Slider=	[
		[128,'lo','VSLIDER',35,50,20,100,'',58,85],
		[128,'lu','VSLIDER',35,200,20,100,'|',58,235],
		[128,'ro','VSLIDER',315,50,20,100,'||',294,85],
		[128,'ru','VSLIDER',315,200,20,100,'|||',294,235],
		[128,'y', 'VSLIDER',5,120,20,100,'||||',28,155],
		[128,'x1','HSLIDER',113,55,140,21,'|||||',96,57],
		[128,'x2','HSLIDER',113,279,140,21,'||||||',96,281]
		];
var maxslider=Slider.length;

var BoolBtn=	[
		['Rotation',95,15,52,25,'open_Multidialog("MultiDeform",4)'],
		['Perspektive',157,15,52,25,'open_Multidialog("MultiDeform",3)'],
		['Beschnitt',219,15,52,25,'open_Multidialog("MultiCanvas",2)'],
		['0-Stellung',356,250,52,25,'reset_slider()'],
		['Lade Einstellungen',356,280,52,25,'load_registry()'],
		['Abbruch',356,320,52,25,'abbrechen()']
		];
var maxbool=BoolBtn.length;

var ModBtn=	[
		['Optimale Auflsung',356,20,52,26,FF_GetImageWidth()],
		['Hchste Auflsung',356,65,52,26,5000],
		['Hohe Auflsung',356,99,52,26,3500],
		['Mittlere Auflsung',356,133,52,26,2500],
		['Mige Auflsung',356,167,52,26,1750],
		['Geringe Auflsung',356,201,52,26,1000]
		];
var maxmod=ModBtn.length;

var DivCtrl=[
		['PV','IMAGE',87,80,previewSize/2,previewSize/2],
		['HighCurve','BOOL',300,170,8,8],
		['Strkere','STATIC',310,166,30,8],
		['Kurven','STATIC',312,174,30,8],
		['Symmetrie','BOOL',125,300,8,8],
		['Symmetrisch bezglich Scheitel-/Wendepunkt','STATIC',135,300,120,8],
		['Dehnen','STATIC',6,112,20,8],
		['Stauchen','STATIC',4,219,22,8],
		['Scheitel-/Wendepunkt horizontal verschieben','STATIC',129,47,130,8],
		['Horizontal nichtlinear Dehnen/Stauchen','STATIC',135,273,125,8],
		['Vorab-Funktionen','GROUP',87,8,192,36]
		];
var maxdivctrl=DivCtrl.length;

var curve_set=false;
var sym_set=false;
var set_break=false;
var moved=false;
var prog_str='xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx';
var proz100=prog_str.length;
var line_dist=Math.round(previewSize/4);
var y_BaseFaktor;

var Mem_saved=true;
var OrigFile="$$MEM:Orig.jpg";
var PictFile="$$MEM:Pict.jpg";

var fso=new ActiveXObject("Scripting.FileSystemObject");
if (Date.parse(fso.GetFile(FF_GetFFPath()+"\\FixFoto.exe").DateLastModified)<Date.parse("February 26,2013 15:00"))
	{Mem_saved=false;OrigFile=FF_GetFFPathEx(1)+"\\Orig.jpg";PictFile=FF_GetFFPathEx(1)+"\\Pict.jpg"};

if (0==FF_GetImageWidth()) {FF_MessageBox("Kein Bild geladen",0)}
else {main();if (!Mem_saved){fso.DeleteFile(OrigFile);fso.DeleteFile(PictFile)};fso=null};

function def_slider()
	{
	for (cnt=0;cnt<maxslider;cnt++)
	{FF_AddControl(SHFT_DLG,Slider[cnt][1],Slider[cnt][2],Slider[cnt][3],Slider[cnt][4],Slider[cnt][5],Slider[cnt][6]); 
	 FF_SetControl(SHFT_DLG,Slider[cnt][1],128);
	 FF_AddControl(SHFT_DLG,"Istwert"+Slider[cnt][7],"STATIC",Slider[cnt][8],Slider[cnt][9],18,7);
	 FF_AddControl(SHFT_DLG,"Sldr_Val"+Slider[cnt][7],"SLEDIT",Slider[cnt][8]+1,Slider[cnt][9]+7,14,9);
	 FF_SetControlStyle(SHFT_DLG,"Sldr_Val"+Slider[cnt][7],1);
	 FF_EnableControl(SHFT_DLG,"Sldr_Val"+Slider[cnt][7],false);
	 if (cnt<maxslider-2)
	 {FF_AddControl(SHFT_DLG,"Sollwert"+Slider[cnt][7],"STATIC",Slider[cnt][8],Slider[cnt][9]+17,20,7);
	  FF_AddControl(SHFT_DLG,"Val_Bool"+Slider[cnt][7],"BOOL",Slider[cnt][8]+5,Slider[cnt][9]+24,8,8)}
	 else
	 {FF_AddControl(SHFT_DLG,"Sollwert"+Slider[cnt][7],"STATIC",Slider[cnt][8]+157,Slider[cnt][9],20,7);
	  FF_AddControl(SHFT_DLG,"Val_Bool"+Slider[cnt][7],"BOOL",Slider[cnt][8]+163,Slider[cnt][9]+8,8,8)};
	 FF_SetControlBuddy(SHFT_DLG,Slider[cnt][1],"Sldr_Val"+Slider[cnt][7])};
	};	

function def_boolbtn()
	{
	for (cnt=0;cnt<maxbool;cnt++)
	{FF_AddControl(SHFT_DLG,BoolBtn[cnt][0],"GROUP",BoolBtn[cnt][1],BoolBtn[cnt][2],BoolBtn[cnt][3],BoolBtn[cnt][4]);
	 FF_AddControl(SHFT_DLG,'|'+cnt,"BOOL",BoolBtn[cnt][1]+4,BoolBtn[cnt][2]+7,BoolBtn[cnt][3]-8,BoolBtn[cnt][4]-10);
	 FF_SetControlStyle(SHFT_DLG,'|'+cnt,4096)}; 
	};

function def_modbtn()
	{
	for (cnt=0;cnt<maxmod;cnt++)
	{if (cnt!=0) {zusatz=''} else {zusatz='|'};
	 FF_AddControl(SHFT_DLG,ModBtn[cnt][0],"GROUP",ModBtn[cnt][1],ModBtn[cnt][2],ModBtn[cnt][3],ModBtn[cnt][4]);
	 FF_AddControl(SHFT_DLG,' ('+ModBtn[cnt][5]+' Pixel)'+zusatz,"STATIC",ModBtn[cnt][1]+11,ModBtn[cnt][2]+22,30,5);
	 FF_AddControl(SHFT_DLG,'BBtn'+cnt,"BOOL",ModBtn[cnt][1]+4,ModBtn[cnt][2]+7,ModBtn[cnt][3]-8,ModBtn[cnt][4]-11)
	 FF_SetControlStyle(SHFT_DLG,'BBtn'+cnt,4096);}; 
	};

function def_divcntrl()
	{
	for (cnt=0;cnt<maxdivctrl;cnt++)
	{FF_AddControl(SHFT_DLG,DivCtrl[cnt][0],DivCtrl[cnt][1],DivCtrl[cnt][2],DivCtrl[cnt][3],DivCtrl[cnt][4],DivCtrl[cnt][5]);} 
	};

function def_progress(x_pos,y_pos)
	{
	FF_AddControl(SHFT_DLG,"Fortschritt","GROUP",x_pos,y_pos,150,25);
	FF_AddControl(SHFT_DLG,"|","STATIC",x_pos+7,y_pos+25,136,9);
	FF_AddControl(SHFT_DLG,"PROG","SLEDIT",x_pos+10,y_pos+10,130,10);
	FF_EnableControl(SHFT_DLG,"PROG",false)
	};

function set_sollwert(index)
	{
	var SollDialog="";
	var Sollwert;
	FF_AddDialog(SollDialog,50,45);
	FF_AddControl(SollDialog,"Sollwerteingabe","GROUP",0,0,50,45);
	FF_AddControl(SollDialog,"Sollwert","SLEDIT",18,13,15,9);
	FF_ActivateControl(SollDialog,"Sollwert")
	FF_AddControl(SollDialog,"Fertig","BUTTON",15,27,20,10);
	for(;;)
	{
	Aktion=FF_ShowDialog(SollDialog);
	if ((Aktion=="Fertig")||(Aktion=="CANCEL"))
	{
	if (Aktion=="Fertig")
  	{Sollwert=parseInt(FF_GetControl(SollDialog,"Sollwert"));
   	 if (!isNaN(Sollwert))
   	 {Sollwert=Math.max(Math.min(Sollwert,255),0);
    	  FF_SetControl(SHFT_DLG,"Sldr_Val"+Slider[index][7],Sollwert);
	  if (Slider[index][2]=="HSLIDER") {FF_SetControl(SHFT_DLG,Slider[index][1],Sollwert)}
	  else {FF_SetControl(SHFT_DLG,Slider[index][1],255-Sollwert)}}};
   	  FF_SetControl(SHFT_DLG,"Val_Bool"+Slider[index][7],false);
	break
	}
	};
	FF_CloseDialog(SollDialog);
	};

function square(wert)
	{return (wert*wert)};

function prepare()
	{
	orgWi=FF_GetImageWidth();
	orgHi=FF_GetImageHeight();
	FF_SaveImage(OrigFile,97);
	if (orgWi>=orgHi) {previewWi=previewSize;previewHi=Math.floor((previewWi/orgWi)*orgHi)}
	else {previewHi=previewSize;previewWi=Math.floor((previewHi/orgHi)*orgWi)};
	FF_HQScale(previewWi,previewHi,false);
        FF_SaveImage(PictFile,97);
	y_BaseFaktor=previewHi/square(previewWi);
	return(true)
	};

function read_slider()
	{
	var index,val,moving;
	for (moving=false,index=0;index<maxslider;index++)
		{
		val=parseInt(FF_GetControl(SHFT_DLG,Slider[index][1]));
		if (val!=Slider[index][0])
		 {moving=true;Slider[index][0]=val}
		};
		if (moving) {moved=true};
		return(moving);
         };

function transform(Height,Width,x_center,for_preview)
	{
	y_Koeffizient=y_BaseFaktor;
	if (curve_set) {y_Koeffizient=y_BaseFaktor*4};
	y_BaseDelta=Height/150;
	delta=(Slider[4][0]-128)*y_BaseDelta;
        y_fakt_ol=y_Koeffizient*(Slider[0][0]/128-1);
        y_fakt_ul=y_Koeffizient*(Slider[1][0]/128-1);
        y_fakt_or=y_Koeffizient*(Slider[2][0]/128-1);
        y_fakt_ur=y_Koeffizient*(Slider[3][0]/128-1);
	horiz_fakt=0.3*(1-Slider[6][0]/128);


//links
	y_obenl=parseInt(Height+delta+y_fakt_ol*square(x_center));
	y_untenl=parseInt(y_fakt_ul*square(x_center));
	if (y_untenl>=y_obenl)
		{
		if (y_fakt_ul<=y_fakt_ol)
		{max_xl=0}
		else
		{max_xl=x_center-Math.floor(Math.sqrt(Math.max((Height+delta)/(y_fakt_ul-y_fakt_ol),0)))};
		y_obenl=Height+delta+y_fakt_ol*square(x_center-max_xl);
		y_untenl=y_obenl
		}
		else
		{max_xl=0};

//rechts
	y_obenr=parseInt(Height+delta+y_fakt_or*square(Width-x_center));
	y_untenr=parseInt(y_fakt_ur*square(Width-x_center));
	if (y_untenr>=y_obenr)
		{
		if (y_fakt_ur<=y_fakt_or)
		{max_xr=Width}
		else
		{max_xr=x_center+Math.floor(Math.sqrt(Math.max((Height+delta)/(y_fakt_ur-y_fakt_or),0)))};
		y_obenr=Height+delta+y_fakt_or*square(max_xr-x_center);
		y_untenr=y_obenr
		}
		else
		{max_xr=Width};

	max_o=Math.max(Math.max(Math.max(y_obenl,y_obenr),Math.max(y_untenl,y_untenr)),Math.floor(Height+delta));
	min_u=Math.min(Math.min(Math.min(y_untenl,y_untenr),Math.min(y_obenl,y_obenr)),0);

//vertikal modifying
        breite=max_xr-max_xl;
	hoehe=max_o-min_u;
	horiz_center=Math.round(Math.max(Math.min(x_center,breite-10),10));
	FF_LoadImage(PictFile);
	FF_PushImage();
	FF_NewImage(breite,hoehe,0xFFFFFF);
	FF_PushImage();
	if (!for_preview){FF_SetControl(SHFT_DLG,"|",CalcInfo)};
	
	x_cnt=max_xl;

	while (x_cnt<max_xr)
	{
	if (!for_preview)
		{if ((x_cnt-max_xl)%100==0)
		 {FF_SetControl(SHFT_DLG,"PROG",prog_str.substr(0,Math.round(proz100*(x_cnt-max_xl)/breite)));FF_RefreshDialog(SHFT_DLG);
		  if (FF_CheckKey()==32){FF_PopImage;FF_PopImage;FF_LoadImage(OrigFile);return}
		}};
	FF_LoadStackImage(0);
	FF_Crop(x_cnt,0,1,Height);
	if (x_cnt<=x_center-1){y_fakt_o=y_fakt_ol;y_fakt_u=y_fakt_ul} else {y_fakt_o=y_fakt_or;y_fakt_u=y_fakt_ur};
	y_oben=parseInt(Height+delta+y_fakt_o*square(x_cnt-x_center));
	y_unten=parseInt(y_fakt_u*square(x_center-x_cnt));
	FF_HQScale(1,y_oben-y_unten,false);
/*
	try
	{FF_MixImage(x_cnt-max_xl,max_o-y_oben,1,Math.max(y_oben-y_unten,0),255);};
	catch (mist)
	{ff_messagebox(mist,0);
	ff_messagebox('x='+(x_cnt-max_xl),0);
	ff_messagebox('maxl='+(max_xl),0);
	ff_messagebox('maxr='+(max_xr),0);
	ff_messagebox('maxo='+(max_o),0);
	ff_messagebox('minu='+(min_u),0);
	ff_messagebox('y_oben='+(y_oben),0);
	ff_messagebox('y_unten='+(y_unten),0);
	ff_messagebox('max_o-y_oben='+(max_o-y_oben),0);
	ff_messagebox('y_oben-y_unten='+(y_oben-y_unten),0);
	ff_messagebox('breite='+(breite),0);
	ff_messagebox('hhe='+(hoehe),0);
	};
*/
	FF_MixImage(x_cnt-max_xl,max_o-y_oben,1,Math.max(y_oben-y_unten,0),255);
	x_cnt++;
	};

//fertig mit vertikal modify
	FF_PopImage;
	FF_SwapImage();

//horizontal modifying
	Stripe_li=Math.round(2*horiz_center/7);
	if (sym_set) {newWi=Math.round(breite*(1-12*horiz_fakt/7))}
	else {newWi=Math.round(breite+12*(breite-2*horiz_center)*horiz_fakt/7)};
	FF_NewImage(newWi,hoehe,0xFFFFFF);
	FF_PushImage();
	Crop_pos=0;x_pos=0;
	for (cnt=1;cnt<=7;cnt++)
	{
	FF_LoadStackImage(0);
	if (cnt<4) {Stripe=Math.round(2*horiz_center/7)}
	else
	{if (cnt>4) {Stripe=Math.round(2*breite/7-Stripe_li)}
	 else {Stripe=Math.round(breite/7);if (sym_set) {horiz_fakt=-horiz_fakt}}};
        ins_Stripe=Math.min(Math.round(Stripe*(1+(cnt-4)*horiz_fakt)),newWi-x_pos);
	if (cnt==7) {Stripe=breite-Crop_pos;ins_Stripe=newWi-x_pos};
	FF_Crop(Crop_pos,0,Stripe,hoehe);
	FF_HQScale(ins_Stripe,hoehe,false);
	FF_MixImage(x_pos,0,ins_Stripe,hoehe,255)
	Crop_pos=Crop_pos+Stripe;
	x_pos=x_pos+ins_Stripe;
	};

//fertig mit horizontal modify
	FF_PopImage();
	FF_SwapImage();
	FF_PopImage();

//Raster einzeichnen
	if (for_preview)
	{
	FF_SetLineType(1,0,0);
	maxbreite=Math.max(breite,newWi);
	y_linepos=line_dist;
	while (y_linepos<hoehe)
	{FF_Line(0,y_linepos,maxbreite,y_linepos,0xFFFFFF,1);y_linepos=y_linepos+line_dist};
	x_linepos=line_dist;
	while (x_linepos<maxbreite)
	{FF_Line(x_linepos,0,x_linepos,hoehe,0xFFFFFF,1);x_linepos=x_linepos+line_dist};
	}

//im Vorschaufenster optimal ausgeben
	realWi=FF_GetImageWidth();realHi=FF_GetImageHeight();
	if (realWi<previewSize)
	{
	if (Math.round(realHi*previewSize/realWi)>previewSize) {hoehe=previewSize;newWi=Math.round(realWi*previewSize/realHi)}
	else {newWi=previewSize;hoehe=Math.round(realHi*previewSize/realWi)};
	FF_HQScale(newWi,hoehe,false);
	};
	FF_SetControl(SHFT_DLG,"PV","0");
	return;
	};

function TimerEvent(ignore_sldr)
	{
	curvechange=((FF_GetControl(SHFT_DLG,"HighCurve")!=0)!=curve_set);
	if (curvechange) {curve_set=!curve_set;FF_SetControl(SHFT_DLG,"HighCurve",curve_set)};
	symchange=((FF_GetControl(SHFT_DLG,"Symmetrie")!=0)!=sym_set);
	if (symchange) {sym_set=!sym_set;FF_SetControl(SHFT_DLG,"Symmetrie",sym_set)};
	if (!symchange && !curvechange && !read_slider() && ignore_sldr) {return};
	transform(previewHi,previewWi,Math.floor(previewWi*(Slider[5][0]/255)),true);
	};
	
function modify(size)
	{
	save_sldr2reg();
	FF_LoadImage(OrigFile);
	modWi=size;
	modHi=Math.floor((modWi/orgWi)*orgHi);
	FF_HQScale(modWi,modHi,false);
        FF_SaveImage(PictFile,97);
	y_BaseFaktor=modHi/square(modWi);
	transform(modHi,modWi,Math.floor(modWi*(Slider[5][0]/255)),false);
	FF_Reload();
	};

function open_Multidialog(type,tab)
	{
	if (moved){FF_MessageBox('Funktion nur bei 0-Stellung der Regler erlaubt!',0)}
	else
	{
	FF_LoadImage(OrigFile);
	FF_SetParam("");
	if (FF_MultiDialog(type,tab)>=0) {prepare();reset_slider()};
	};
	TimerEvent(false);
	};

function reset_slider()
	{
	for (index=0;index<maxslider;index++)
	{if (Slider[index][2]=='VSLIDER')
	 {FF_SetControl(SHFT_DLG,Slider[index][1],127)}
	 else {FF_SetControl(SHFT_DLG,Slider[index][1],128)};
	 FF_SetControl(SHFT_DLG,"Sldr_Val"+Slider[index][7],128)};
	TimerEvent(true); 
	FF_SetControl(SHFT_DLG,"HighCurve",false);
	FF_SetControl(SHFT_DLG,"Symmetrie",false);
	moved=false;
	};

function load_registry()
	{
	for (index=0;index<maxslider;index++)
	{Value=parseInt(FF_GetProfile("Verzerr",Slider[index][1]));
	 if (!isNaN(Value)) 
	 {if ((Value>=0)&&(Value<=255))
		{FF_SetControl(SHFT_DLG,"Sldr_Val"+Slider[index][7],Value);
	   	 if (index<maxslider-2) {FF_SetControl(SHFT_DLG,Slider[index][1],255-Value)}
		 else {FF_SetControl(SHFT_DLG,Slider[index][1],Value)}}}};
	FF_SetControl(SHFT_DLG,"HighCurve",(FF_GetProfile("Verzerr","sk")!=0));
	FF_SetControl(SHFT_DLG,"Symmetrie",(FF_GetProfile("Verzerr","sy")!=0));
	};

function save_sldr2reg()
	{
	for (index=0;index<maxslider;index++)
	{FF_WriteProfile("Verzerr",Slider[index][1],Slider[index][0])};
	FF_WriteProfile("Verzerr","sk",FF_GetControl(SHFT_DLG,"HighCurve"));
	FF_WriteProfile("Verzerr","sy",FF_GetControl(SHFT_DLG,"Symmetrie"));
	};

function abbrechen()
	{
	FF_LoadImage(OrigFile);FF_Reload();set_break=true
	};

function check_boolbtn(inx)
	{
	if (FF_GetControl(SHFT_DLG,'|'+inx)!=0)
	{eval(BoolBtn[inx][5]);FF_SetControl(SHFT_DLG,'|'+inx,false)};
	};

function main()
	{
	var inx;
	prepare();

//Definition des Dialogs
	FF_AddDialog(SHFT_DLG,420,353);
//Slider definieren
	def_slider();
//diverse Bool-Buttons definieren
	def_boolbtn();
//Modify-Buttons definieren
        def_modbtn();
//Diverse Controlelemente definieren
	def_divcntrl()
//Progress-Anzeige definieren
	def_progress(106,313);

//Initialisierung Vorschau
	transform(previewHi,previewWi,Math.floor(previewWi*(Slider[5][0]/255)),true);
//Dialogabfrage-Schleife
	for(;;)
	{
	FF_SetDialogTimer(SHFT_DLG,10);

	Rtrn=FF_ShowDialog(SHFT_DLG);

	if (Rtrn=="CANCEL") {FF_LoadImage(OrigFile);FF_Reload();break};

	if (Rtrn=="TIMER")
		{
		FF_SetDialogTimer(SHFT_DLG,0);
		TimerEvent(true);

		for (inx=0;inx<maxmod;inx++)
		{if (FF_GetControl(SHFT_DLG,"BBtn"+inx)!=0)
		 {modify(ModBtn[inx][5]);
		  FF_SetControl(SHFT_DLG,"BBtn"+inx,false);return}};

		for (inx=0;inx<maxbool;inx++) {check_boolbtn(inx)};

		for (inx=0;inx<maxslider;inx++)
		{if (FF_GetControl(SHFT_DLG,"Val_Bool"+Slider[inx][7])!=0) {set_sollwert(inx)}};

		if (set_break) {break};

		};
			
	};
	FF_CloseDialog(SHFT_DLG);
	}
